%INPUT IS A PUZZLE

function out = EggSolver(x)

%SEGMENTING
fprintf('SEGMENTING\n');
puzzle = KappaSegmentationEgg(x);

% figure(1); hold on
% for i=1:length(x)
% plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
% end

%CALCULATING SIMILARITY SCORE
%score is stored so that first entry is matching piece, second is matching
%edge, and third entry is the similarity score
fprintf('SKEWNESS CALCULATION\n');
num = 0;
for h=1:length(x) %SET PIECE
    if (isempty(puzzle(h).edge))
        continue
    end
    for j=1:length(puzzle(h).edge(:,1)) %SET EDGE
        cnt = 0; 
        for k=1:length(x) %COMPARATIVE PIECE
            if h==k
                continue
            end
            if isempty(puzzle(k).edge)
                continue
            end
            
            %LENGTH OF SET EDGE
            distances = zeros(1,2);
            for m=2:length(puzzle(h).edge{j,1}(:,1))
                distances(1) = sqrt((puzzle(h).edge{j,1}(m,1)-puzzle(h).edge{j,1}(m-1))^2+ ...
                    (puzzle(h).edge{j,1}(m,2)-puzzle(h).edge{j,1}(m-1,2))^2+ ...
                    (puzzle(h).edge{j,1}(m,3)-puzzle(h).edge{j,1}(m-1,3))^2)+ distances(1);
            end
            
            for m=1:length(puzzle(k).edge(:,1)) %COMPARATIVE EDGE
                %LENGTH OF COMPARATIVE EDGE
                distances(2) = 0;
                for n=2:length(puzzle(h).edge{j,1}(:,1))
                    distances(2) = sqrt((puzzle(k).edge{m,1}(n,1)-puzzle(k).edge{m,1}(n-1))^2+ ...
                        (puzzle(k).edge{m,1}(n,2)-puzzle(k).edge{m,1}(n-1,2))^2+ ...
                        (puzzle(k).edge{m,1}(n,3)-puzzle(k).edge{m,1}(n-1,3))^2)+distances(2);
                end
                
                %DETERMINING WHETHER TO CALCULATE THE SIMILARITY SCORE
                if min(distances)/max(distances)<0.6
                    skew = 10;
                else
                    skew = compareEgg3D(puzzle(k).edge{m,2},puzzle(h).edge{j,2});
                end
                
                cnt                        = cnt+1;
                puzzle(h).edge{j,3}(cnt,1) = skew;
                puzzle(h).edge{j,3}(cnt,2) = k; 
                puzzle(h).edge{j,3}(cnt,3) = m;
                
                if (h<k)
                    num               = num+1;
                    skewMatrix(num,1) = skew;
                    skewMatrix(num,2) = h;
                    skewMatrix(num,3) = j;
                    skewMatrix(num,4) = k;
                    skewMatrix(num,5) = m;
                end          
            end
        end
        puzzle(h).edge{j,3} = sortrows(puzzle(h).edge{j,3},1);
    end
end

skewMatrix = sortrows(skewMatrix,1);

%CREATING SOLUTION STRUCTURE
for h=1:length(x)
    sol(h).pieces=h; sol(h).match=[];
    if (isempty(puzzle(h).edge)==0)
        for i=1:length(puzzle(h).edge(:,1))
            sol(h).edge{i,1} = zeros(1,2);
            sol(h).edge{i,2} = zeros(1,2);
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%
%%% GENERAL ASSEMBLY %%%
%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('GENERAL SOLVE\n');

gencnt  = 0;
starcnt = 0;
path    = 0;
for i=1:length(skewMatrix)

    fprintf('(%d,%d) and (%d,%d) with skew = %f\n',skewMatrix(i,2),skewMatrix(i,3),skewMatrix(i,4),skewMatrix(i,5),skewMatrix(i,1));
    PutTogether(puzzle(skewMatrix(i,2)).edge{skewMatrix(i,3),4},puzzle(skewMatrix(i,4)).edge{skewMatrix(i,5),4},puzzle(skewMatrix(i,2)).piece,puzzle(skewMatrix(i,4)).piece);
    
    while path<1 && path >4
        path = input('Enter 1 for accept.\n Enter 2 for reject? \n Enter 3 for star \n Enter 4 to quit');
    end
    
    if path==1
        gencnt                   = gencnt+1;
        genericMatches(gencnt,:) = skewMatrix(i,:);
    elseif path==3
        starcnt                  = starcnt+1;
        starMatches(starcnt,:)   = skewMatrix(i,:);
    elseif path==4
        break
    end
    
end





out{1} = starMatches;
out{2} = genericMatches;
%out    = puzzle;

end
%% PROBLEMS

%THERE MIGHT BE A PROBLEM WITH ASSEMBLYING UNMOVED PIECES TO MOVED PIECES

% UPDATE MOVED AFTER SOLUTION UPDATE
% CHECK ADJACENT EDGES, IF MATCHING EDGES ARE SAME PIECE