%INPUT SHOULD BE THE ENTIRE PUZZLE AS AN ARRAY

function out = KappaS_SegmentationEgg(x)

%ACQUIRING SIGNATURE CURVE DATA
for i=length(x):-1:1
    
    x{i,1}(end,:) = x{i,1}(1,:);
    
%     figure(1); hold on
%     plot3(x{i,1}(:,1),x{i,1}(:,2),x{i,1}(:,3),'LineWidth',2);
    inch = 0.00002;
    if i==1
        puzzle(i).piece = Smoother(x{i,1},0.00006+inch);
    elseif i==2
        puzzle(i).piece = Smoother(x{i,1},0.000028+inch);
    elseif i==3
        puzzle(i).piece = Smoother(x{i,1},0.00007+inch);
    elseif i==4
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==5
        puzzle(i).piece = Smoother(x{i,1},0.000015+inch);
    elseif i==6
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==7
        puzzle(i).piece = Smoother(x{i,1},0.00006+inch);
    elseif i==9
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==10
        puzzle(i).piece = Smoother(x{i,1},0.00002+inch);
    elseif i==11
        puzzle(i).piece = Smoother(x{i,1},0.0000275+inch);
    else
        puzzle(i).piece = Smoother(x{i,1},0.00005+inch);
    end
    
%     plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
%     
%     figure(2);
%     plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
    
    temp            = compsig(puzzle(i).piece')';
    puzzle(i).sig   = temp(:,1:3);
end

%DELETING NaN VALUES
for h=1:length(x);
    cnt   = 0;
    piece = [];
    sig   = [];
    for i=1:length(puzzle(h).sig(:,1))
        if (isfinite(puzzle(h).sig(i,1)) && ...
                isfinite(puzzle(h).sig(i,2)) && ...
                isfinite(puzzle(h).sig(i,3)) && ...
                isfinite(puzzle(h).piece(i,1)) && ...
                isfinite(puzzle(h).piece(i,2)) && ...
                isfinite(puzzle(h).piece(i,3)))
            
            cnt          = cnt+1;
            piece(cnt,:) = puzzle(h).piece(i,:);
            sig(cnt,:)   = puzzle(h).sig(i,:);
        end
    end
    puzzle(h).sig = [];     puzzle(h).piece = [];
    puzzle(h).sig = sig;    puzzle(h).piece = piece;   
end

%SEGMENTATION
for h=1:length(x);
    num   = 1;
    cnt   = 1;

    for i=2:length(puzzle(h).sig(:,1))
        if (sign(puzzle(h).sig(i,2))==sign(puzzle(h).sig(i-1,2)))
            cnt                          = cnt+1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
        else
            num                          = num+1;
            cnt                          = 1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
        end
    end 
end

%SIPHONING SEGMENTS 
for h=1:length(x)
    for i=length(puzzle(h).edge(:,1)):-1:1
        if isempty(puzzle(h).edge{i,1})
            continue
        end
        if length(puzzle(h).edge{i,2})<30
            puzzle(h).edge{i,1} = []; 
            puzzle(h).edge{i,2} = []; 
        end
    end
end

%RESTRUCTURING SEGMENTS
for h=1:length(x)
    cnt=0; here=[];
    for i=1:length(puzzle(h).edge(:,1))
        if isempty(puzzle(h).edge{i,1})==0
            cnt         = cnt+1;
            here{cnt,1} = puzzle(h).edge{i,1};
            here{cnt,2} = puzzle(h).edge{i,2};
        end
    end
    puzzle(h).edge = []; puzzle(h).edge = here;
end

%SMOOTHING SEGMENTS
for h=1:length(x);
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            puzzle(h).edge{i,1} = SmootherSegments(puzzle(h).edge{i,1},.00000000001);
            puzzle(h).edge{i,2} = SmootherSegments(puzzle(h).edge{i,2},.00000000001);
        end
    end
end

out=puzzle;

end

%%