%INPUT SHOULD BE THE ENTIRE PUZZLE AS AN ARRAY

function out = KappaSegmentationEgg(x)

%ACQUIRING SIGNATURE CURVE DATA
for i=length(x):-1:1
    
    x{i,1}(end,:) = x{i,1}(1,:);
    
%         figure(1); hold on
%         plot3(x{i,1}(:,1),x{i,1}(:,2),x{i,1}(:,3),'LineWidth',2);
    inch = 0.00002;
    if i==1
        puzzle(i).piece = Smoother(x{i,1},0.00007+inch);
    elseif i==2
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==3
        puzzle(i).piece = Smoother(x{i,1},0.00007+inch);
    elseif i==4
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==5
        puzzle(i).piece = Smoother(x{i,1},0.000015+inch);
    elseif i==6
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==7
        puzzle(i).piece = Smoother(x{i,1},0.00006+inch);
    elseif i==9
        puzzle(i).piece = Smoother(x{i,1},0.00003+inch);
    elseif i==10
        puzzle(i).piece = Smoother(x{i,1},0.00002+inch);
    elseif i==11
        puzzle(i).piece = Smoother(x{i,1},0.00002+inch);
    elseif i==13
        puzzle(i).piece = Smoother(x{i,1},0.00015+inch);
    elseif i==14
        puzzle(i).piece = Smoother(x{i,1},0.00002+inch);
    else
        puzzle(i).piece = Smoother(x{i,1},0.00005+inch);
    end
    
%         plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
%     
%         figure(2);
       % plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
    
    temp            = compsig(puzzle(i).piece')';
    puzzle(i).sig   = temp(:,1:3);
end

%DELETING NaN VALUES
for h=1:length(x);
    cnt   = 0;
    piece = [];
    sig   = [];
    for i=1:length(puzzle(h).sig(:,1))
        if (isfinite(puzzle(h).sig(i,1)) && ...
                isfinite(puzzle(h).sig(i,2)) && ...
                isfinite(puzzle(h).sig(i,3)) && ...
                isfinite(puzzle(h).piece(i,1)) && ...
                isfinite(puzzle(h).piece(i,2)) && ...
                isfinite(puzzle(h).piece(i,3)))
            
            cnt          = cnt+1;
            piece(cnt,:) = puzzle(h).piece(i,:);
            sig(cnt,:)   = puzzle(h).sig(i,:);
        end
    end
    puzzle(h).sig = [];     puzzle(h).piece = [];
    puzzle(h).sig = sig;    puzzle(h).piece = piece;
end

%SEGMENTATION
for h=1:length(x);
    index = 1;
    num   = 1;
    cnt   = 1;
    while (abs(puzzle(h).sig(index,1))<18.5)
        index = index+1;
    end
    puzzle(h).edge{num,1}(1,:) = puzzle(h).piece(index,:);
    puzzle(h).edge{num,2}(1,:) = puzzle(h).sig(index,:);
    for i=index+1:length(puzzle(h).sig(:,1))
        if abs(puzzle(h).sig(i,1))>18.5 && sign(puzzle(h).sig(i,1))==sign(puzzle(h).sig(i-1,1))
            cnt = cnt+1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
            puzzle(h).edge{num,4}(cnt)   = i;
        else
            num = num+1;
            cnt = 1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
            puzzle(h).edge{num,4}(cnt)   = i;
        end
    end
end

%SIPHONING SEGMENTS
for h=1:length(x)
    for i=length(puzzle(h).edge(:,1)):-1:1
        if isempty(puzzle(h).edge{i,1})
            continue
        end
        if length(puzzle(h).edge{i,2})<20
            puzzle(h).edge{i,1} = [];
            puzzle(h).edge{i,2} = [];
            puzzle(h).edge{i,4} = [];
        end
    end
end

%RESTRUCTURING SEGMENTS
for h=1:length(x)
    cnt=0; here=[];
    for i=1:length(puzzle(h).edge(:,1))
        if isempty(puzzle(h).edge{i,1})==0
            cnt         = cnt+1;
            here{cnt,1} = puzzle(h).edge{i,1};
            here{cnt,2} = puzzle(h).edge{i,2};
            here{cnt,4} = puzzle(h).edge{i,4};
        end
    end
    puzzle(h).edge = []; puzzle(h).edge = here;
end

%DETECTING VERY LONG SEGMENTS
for h=1:length(x)
    if isempty(puzzle(h).edge)
        continue
    end
    
    cnt = length(puzzle(h).edge(:,1));
    for i=1:length(puzzle(h).edge(:,1))
        if length(puzzle(h).edge{i,1}(:,1))>150
            cnt = cnt+1;
            mid = round(length(puzzle(h).edge{i,1}(:,1))/2);
            puzzle(h).edge{cnt,1} = puzzle(h).edge{i,1}(mid:end,:);
            puzzle(h).edge{cnt,2} = puzzle(h).edge{i,2}(mid:end,:);
            puzzle(h).edge{cnt,4} = puzzle(h).edge{i,4}(mid:end);
            
            puzzle(h).edge{i,1}(mid:end,:) = [];
            puzzle(h).edge{i,2}(mid:end,:) = [];
            puzzle(h).edge{i,4}(mid:end)   = [];
        end
    end
end

%SMOOTHING SEGMENTS
for h=1:length(x);
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            indices             = [];
            puzzle(h).edge{i,1} = SmootherSegments(puzzle(h).edge{i,1},.00000001);
            puzzle(h).edge{i,2} = SmootherSegments(puzzle(h).edge{i,2},.00000001);
            indices             = puzzle(h).edge{i,4};
            puzzle(h).edge{i,4} = [];
            
            %PRECEDING 50 POINTS
            for j=20:-1:1
                if indices(1)-j>0
                    puzzle(h).edge{i,4}(end+1,:) = puzzle(h).piece(indices(1)-j,:);
                else
                    puzzle(h).edge{i,4}(end+1,:) = puzzle(h).piece(indices(1)-j+length(puzzle(h).piece(:,1)),:);
                end
            end
            
            %INSERTING EDGE
            for j=1:length(puzzle(h).edge{j,1}(:,1))
                puzzle(h).edge{i,4}(end+1,:) = puzzle(h).edge{i,1}(j,:);
            end
            
            %SUCCEDING 50 POINTS
            for j=1:20
                if indices(end)+j<=length(puzzle(h).piece(:,1))
                    puzzle(h).edge{i,4}(end+1,:) = puzzle(h).piece(indices(end)+j,:);
                else
                    puzzle(h).edge{i,4}(end+1,:) = puzzle(h).piece(indices(end)+j-length(puzzle(h).piece(:,1)),:);
                end
            end
            
            %             figure(2); hold on
            %             plot3(test1(3:end-3,1),test1(3:end-3,2),test1(3:end-3,3),'r');
            %             plot3(test1(3:end-3,1),test1(3:end-3,2),test1(3:end-3,3),'.r');
            %             plot3(puzzle(h).edge{i,2}(:,1),puzzle(h).edge{i,2}(:,2),puzzle(h).edge{i,2}(:,3),'k')
            %             plot3(puzzle(h).edge{i,2}(:,1),puzzle(h).edge{i,2}(:,2),puzzle(h).edge{i,2}(:,3),'.k')
        end
    end
end


out=puzzle;

end

%%