function [out1,out2,out3] = UpdateSolution(puzzle,sol,clusters)

%CLEARING SOLUTION STRUCTURE
for h=1:length(puzzle)
    sol(h).match = [];
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            sol(h).edge{i,1} = zeros(1,2);
            sol(h).edge{i,2} = zeros(1,2);
        end
    end
end

%COMPILING SOLUTION MATRIX BASED ON SOLVED PIECES
for h=1:length(puzzle)
    if isempty(puzzle(h).edge)==0
        for i=1:length(puzzle(h).edge(:,1))
            for j=1:length(puzzle)
                if h==j
                    continue
                end
                if isempty(puzzle(j).edge)==0
                    for k=1:length(puzzle(j).edge(:,1))
                        distances = zeros(1,2);
                        edge1     = puzzle(j).edge{k,1};
                        edge2     = puzzle(h).edge{i,1};
                        
                        for m=2:length(edge1(:,1))
                            distances(1) = sqrt((edge1(m,1)-edge1(m-1,1))^2+(edge1(m,2)-edge1(m-1,2))^2+(edge1(m,3)-edge1(m-1,3))^2)+distances(1);
                            distances(2) = sqrt((edge2(m,1)-edge2(m-1,1))^2+(edge2(m,2)-edge2(m-1,2))^2+(edge2(m,3)-edge2(m-1,3))^2)+distances(2);
                        end
                        distances = sort(distances);
                        
                        %DETERMINING WHETHER THE EDGES ARE A MATCH
                        if HausdorffDist(puzzle(j).edge{k,1},puzzle(h).edge{i,1})<0.07 && distances(1)/distances(2)>0.8
                            sol(h).edge{i,1}(1,1) = h;  sol(j).edge{k,1}(1,1) = j;
                            sol(h).edge{i,1}(1,2) = i;  sol(j).edge{k,1}(1,2) = k;
                            sol(h).edge{i,2}(1,1) = j;  sol(j).edge{k,2}(1,1) = h;
                            sol(h).edge{i,2}(1,2) = k;  sol(j).edge{k,2}(1,2) = i;
                            sol(h).match(end+1)   = j;  sol(j).match(end+1)   = h;
                            
                            sol(h).match = unique(sol(h).match);
                            sol(j).match = unique(sol(j).match);
                            %UPDATING CLUSTERS
                            piece1Cluster = 0;
                            piece2Cluster = 0;
                            for n=1:length(clusters(:,1))
                                if ismember(h,clusters{n,1})
                                    piece1Cluster = n;
                                elseif ismember(j,clusters{n,1})
                                    piece2Cluster = n;
                                end
                            end
                            
                            %CREATING OR COMBINING CLUSTERS
                            if piece1Cluster==0 && piece2Cluster==0
                                clusters{length(clusters(:,1))+1,1}  = h;
                                clusters{length(clusters(:,1)),1}(2) = j;
                            elseif piece1Cluster>0 && piece2Cluster==0
                                clusters{piece1Cluster,1}(end+1) = j;
                            elseif piece1Cluster==0 && piece2Cluster>0
                                clusters{piece2Cluster,1}(end+1) = h;
                            elseif piece1Cluster>0 && piece2Cluster>0
                                if length(clusters{piece1Cluster,1}(:,1))>length(clusters{piece2Cluster,1}(:,1))
                                    for p=1:length(clusters{piece2Cluster,1}(:,1))
                                        clusters{piece1Cluster,1}(end+1) = clusters{piece2Cluster,1}(p);
                                        clusters{piece1Cluster,1} = unique(clusters{piece1Cluster,1});
                                    end
                                else
                                    for p=1:length(clusters{piece1Cluster,1}(:,1))
                                        clusters{piece2Cluster,1}(end+1) = clusters{piece1Cluster,1}(p);
                                    end
                                    clusters{piece2Cluster,1} = unique(clusters{piece2Cluster,1});
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

%SIPHONING MATCH STRUCTURE
for h=1:length(puzzle)
    sol(h).match = unique(sol(h).match);
end

for h=1:length(clusters(:,1))
    clusters{h,1} = unique(clusters{h,1});
end

%OUTPUTS
out1 = puzzle;
out2 = sol;
out3 = clusters;
end


%%