%CLEARS ALL VARIABLES AND CLOSES WINDOWS
clear all;
close all;
%QUESTIONS
n_points=input('ENTER NUMBER OF PUZZLE PIECES(>9):');
style=input('\nFOR TRADITIONAL EDGES ENTER 1\n FOR NONTRADITIONAL EDGES ENTER 2:');
fprintf('\n WOULD YOU LIKE AN ELLIPTICAL PUZZLE?\n');
ellip=input('ENTER 1 FOR YES OR 2 FOR NO?:');

den     = (4*pi)/n_points; 
n_shelv = round(pi/den); 
phivec  = 0:pi/(n_shelv):pi;
ptvec   = cell(n_shelv,1);
if n_shelv==1
    n_shelv=2;
end

%CHECKING THAT NUMBER OF POINTS IS EQUAL TO USER INPUT
n_ptring = 0;
for i=2:(n_shelv)
    phi1           = phivec(i); 
    phi2           = phivec(i-1);
    area(i-1)      = 2*pi*(abs(cos(phi1)-cos(phi2)));
    numPoints(i-1) = round(2*pi*(abs(cos(phi1)-cos(phi2)))/den);
    density(i-1)   = area(i-1)/numPoints(i-1); 
end

while sum(numPoints)<n_points
    [low, index]     = min(density(i-1));
    numPoints(index) = numPoints(index)+1;
    density(index)   = area(i-1)/numPoints(index);
end



%FILLING POINT MATRIX
for i=2:(n_shelv)
    phi1     = phivec(i); 
    phi2     = phivec(i-1);
    n_ptring = numPoints(i-1);
    theta    = 0; 
    deltheta = (2*pi)/n_ptring;
    
    %ADJUSTING PHI, PHI=0 IS THE X-AXIS
    for j=1:round(n_ptring)
        if j==1
            if phi1>pi/2
                phi1=pi/2-phi1;
            else
                phi1=-1*(phi1-pi/2);
            end
        end
        ptvec{i,1}(j,1)=1;
        ptvec{i,1}(j,2)=phi1;
        theta=theta+deltheta;
        ptvec{i,1}(j,3)=theta;
    end
end

%DETERMINING START AND END POINTS OF SHIFT
if n_points<100
    inc=1;
elseif n_points>=100 && n_points<200
    inc=3;
elseif n_points>=200 && n_points<=300
    inc=4;
else
    inc=8;
end

%SHIFT POINTS BY DELTA THETA
for i=3:inc:length(ptvec)-3
    if i==1 || (length(ptvec{i-1,1})<4)
        continue
    end
    delth=(abs(ptvec{i-1,1}(1,3)-ptvec{i-1,1}(2,3)))/2;
    for j=1:length(ptvec{i,1})
        ptvec{i,1}(j,3)=ptvec{i,1}(j,3)+delth;
    end
end

%TRANSFERRING PTVEC FROM ARRAY TO MATRIX
for k=1:length(ptvec)
    if isempty(ptvec{k,1})==0
        break
    end
end
cnt=0;
for b=length(ptvec):-1:1
    if isempty(ptvec{b,1})==0
        break
    end
    cnt=cnt+1;
end
data=ptvec{k,1}; init=k; 
for i=(init+1):length(ptvec)-cnt
    len=length(data(:,1));
    data((len+1):(len+length(ptvec{i,1}(:,1))),1:3)=ptvec{i,1}(:,1:3);
end

%CONVERTING PTS FROM SPHERICAL TO CARTESIAN
for i=1:length(data(:,1))
    [x,y,z]=sph2cart(data(i,3),data(i,2),data(i,1));
    data(i,1)=x; data(i,2)=y; data(i,3)=z;
end

%CALLS FUNCTION THAT GENERATES SPHERICAL VORONOI
[Vertices, K, voronoiboundary] = voronoisphere(data');

%DATA IS THE CENTER POINT OF EACH PUZZLE PIECE

% figure(1); hold on
% plot3(Vertices(1,:)',Vertices(2,:)',Vertices(3,:)','g.');
% plot3(data(:,1),data(:,2),data(:,3),'.r');
% xlabel('X-AXIS'); ylabel('Y-AXIS'); zlabel('Z-AXIS');

t=size(K); cells=t(1);
for i=1:cells
    e=(voronoiboundary{i})';
    x=e(:,1); y=e(:,2); z=e(:,3);
    plot3(x,y,z,'--');
end

vert=Vertices';
for i=1:length(data(:,1))
    pieces(i).center = [data(i,1),data(i,2),data(i,3)];
    pieces(i).done = 0;
    pieces(i).edges = vert(K{i},:);
end

for h=1:length(pieces)
    temp=[];
    temp=pieces(h).edges;
    for i=1:length(pieces(h).edges(:,1))-1
        temp(i,4:6)=temp(i+1,1:3);
    end
    temp(end,4:6)=temp(1,1:3);
    pieces(h).edges=temp;
end

%DETERMINES ADJACENT PIECES
%         COLUMN 1: PUZZLE PIECE
%         COLUMN 2: PUZZLE EDGE
%         COLUMN 3: MATCHING PIECE
%         COLUMN 4: MATCHING EDGE INDEX
for i=1:(length(data(:,1)))
    adjcont=0;
    for j=1:(length(data(:,1)))
        if i==j
            continue
        end
        for k=1:length(pieces(i).edges(:,1))
            for l=1:length(pieces(j).edges(:,1))
                if sort(pieces(i).edges(k,:))==sort(pieces(j).edges(l,:))
                    adjcont=1+adjcont;
                    adj{i,1}(adjcont,1)=j;
                    pieces(i).adjacents(adjcont,1)=i;
                    pieces(i).adjacents(adjcont,2)=k;
                    pieces(i).adjacents(adjcont,3)=j;
                    pieces(i).adjacents(adjcont,4)=l;   
                end 
            end
        end
    end
end

%DETERMINES INPUTS TO CURVY EDGE GENERATOR
for i=1:length(pieces)
    for m=1:length(pieces(i).edges(:,1)) %m IS THE EDGE# WE ARE ON
       %SEARCHING FOR ADJACENT PIECE 
       for n=1:length(pieces(i).adjacents(:,1))
          if (m==pieces(i).adjacents(n,2))
              adjacentPiece=pieces(i).adjacents(n,3);
              adjacentEdges=pieces(i).adjacents(n,4);
              break
          end
       end
       %CHECK IF EDGE HAS ALREADY BEEN CREATED
       if adjacentPiece<i
           curvypieces(i).edges{m,1}=curvypieces(adjacentPiece).edges{adjacentEdges,1};
           continue %MOVE ONTO NEXT EDGE
       end
       %DEFINING INPUT TO BEZIER CURVE GENERATOR
        initial  = pieces(i).edges(m,1:3);       % INITIAL POINT OF EDGE
        final   = pieces(i).edges(m,4:6);       % FINIAL POINT OF EDGE
        control1 = pieces(adjacentPiece).center; % CONTROL POINT
        control2 = pieces(i).center;             % CONTROL POINT   
        %USER INPUT PATHS
        if style==1
            curvypieces(i).edges{m,1}=JigsawEdge(initial,control1,control2,final);
        else
            curvypieces(i).edges{m,1}=CurvyEdge(initial,control1,control2,final);
        end
        shift=[];
        if ellip==1
            edge=curvypieces(i).edges{m,1};
            for t=1:length(curvypieces(i).edges{m,1}(:,1))
                shift(:,t)=[1,0,1.1;
                            0,1,1.1;
                            0,0,1;]*edge(t,:)';
            end
            curvypieces(i).edges{m,1} = shift';
        end
    end
    curvypieces(i).center = pieces(i).center;
    curvypieces(i).done = 0;
    curvypieces(i).adjacents=pieces(i).adjacents;
end

%CHECKING ORDER OF SEGMENTS
for h=1:length(curvypieces)
    %ORIENTATING FIRST EDGE SEGMENT
    if (curvypieces(h).edges{1,1}(1,:)~=curvypieces(h).edges{length(curvypieces(h).edges(:,1)),1}(end,:))
       if (curvypieces(h).edges{1,1}(end,:)==curvypieces(h).edges{length(curvypieces(h).edges(:,1)),1}(end,:))
           curvypieces(h).edges{1,1}=(fliplr(curvypieces(h).edges{1,1}'))';
       elseif (curvypieces(h).edges{1,1}(end,:)==curvypieces(h).edges{length(curvypieces(h).edges(:,1)),1}(1,:))
           curvypieces(h).edges{1,1}=(fliplr(curvypieces(h).edges{1,1}'))';
       end     
    end
    %ORIENTATING REMAINING SEGMENTS
    for i=2:length(curvypieces(h).edges(:,1))
        if curvypieces(h).edges{i-1,1}(end,:)~=curvypieces(h).edges{i,1}(1,:)
            curvypieces(h).edges{i,1}=(fliplr(curvypieces(h).edges{i,1}'))';
        end
    end 
end

%REMOVE SHARP EDGES
for i=1:length(curvypieces)
    for j=length(curvypieces(i).edges):-1:1
        edge=curvypieces(i).edges{j,1};
        dist=sqrt((edge(1,1)-edge(end,1))^2+(edge(1,2)-edge(end,2))^2+(edge(1,3)-edge(end,3))^2);
        if dist<0.1
            curvypieces(i).edges{j,1}(2:end-1,:)=[];
        end
    end
end
 
%CREATING PUZZLE ARRAY
puzzle=cell(length(curvypieces),1);
clear data
for i=1:length(curvypieces)
    data=[];
    data=curvypieces(i).edges{1,1};
    for j=2:length(curvypieces(i).edges)
        len=length(data(:,1));
        data(len+1:(len+length(curvypieces(i).edges{j}(:,1))),1)=curvypieces(i).edges{j}(:,1);
        data(len+1:(len+length(curvypieces(i).edges{j}(:,1))),2)=curvypieces(i).edges{j}(:,2);
        data(len+1:(len+length(curvypieces(i).edges{j}(:,1))),3)=curvypieces(i).edges{j}(:,3);
    end
    puzzle{i}=data;
end

%PLOT RESULTING PUZZLE
figure(1); hold on
for i=1:length(curvypieces)
    for j=1:length(curvypieces(i).edges)
            plot3(curvypieces(i).edges{j,1}(:,1),curvypieces(i).edges{j,1}(:,2),curvypieces(i).edges{j,1}(:,3),'LineWidth',2);
    end
end
 
clearvars -EXCEPT puzzle;
