%INPUT SHOULD BE THE ENTIRE PUZZLE AS AN ARRAY

function out = KappaS_Segmentation(x)

%ACQUIRING SIGNATURE CURVE DATA
for i=1:length(x)
    t               = [];
    t               = Noise(x{i,1});
    result          = Smoother(t,0.02);
    temp            = compsig(result')';
    shift           = rand;
    trans(1:3,1)    = 10*shift; 
    
    for j=1:length(result(:,1))
       insy(j,:)    = (result(j,:)'+trans)'; 
    end
    puzzle(i).piece = insy(:,1:3);
    puzzle(i).sig   = temp(:,1:3);    
end

%DELETING NaN VALUES
for h=1:length(x);
    cnt   = 0;
    piece = [];
    sig   = [];
    for i=1:length(puzzle(h).sig(:,1))
        if (isfinite(puzzle(h).sig(i,1)) && ...
                isfinite(puzzle(h).sig(i,2)) && ...
                isfinite(puzzle(h).sig(i,3)) && ...
                isfinite(puzzle(h).piece(i,1)) && ...
                isfinite(puzzle(h).piece(i,2)) && ...
                isfinite(puzzle(h).piece(i,3)))
            
            cnt          = cnt+1;
            piece(cnt,:) = puzzle(h).piece(i,:);
            sig(cnt,:)   = puzzle(h).sig(i,:);
        end
    end
    puzzle(h).sig = [];     puzzle(h).piece = [];
    puzzle(h).sig = sig;    puzzle(h).piece = piece;   
end

%SEGMENTATION
for h=1:length(x);
    num   = 1;
    cnt   = 1;

    for i=2:length(puzzle(h).sig(:,1))
        if (sign(puzzle(h).sig(i,2))==sign(puzzle(h).sig(i-1,2)))
            cnt                          = cnt+1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
        else
            num                          = num+1;
            cnt                          = 1;
            puzzle(h).edge{num,1}(cnt,:) = puzzle(h).piece(i,:);
            puzzle(h).edge{num,2}(cnt,:) = puzzle(h).sig(i,:);
        end
    end 
end

%SIPHONING SEGMENTS
for h=1:length(x)
    for i=length(puzzle(h).edge(:,1)):-1:1
        if isempty(puzzle(h).edge{i,1})==0 && length(puzzle(h).edge{i,2})<20
            puzzle(h).edge{i,1} = []; 
            puzzle(h).edge{i,2} = [];
        end        
    end
end

%RESTRUCTURING SEGMENTS
for h=1:length(x)
    cnt=0; here=[];
    for i=1:length(puzzle(h).edge(:,1))
        if isempty(puzzle(h).edge{i,1})==0
            cnt         = cnt+1;
            here{cnt,1} = puzzle(h).edge{i,1};
            here{cnt,2} = puzzle(h).edge{i,2};
        end
    end
    puzzle(h).edge = []; 
    puzzle(h).edge = here;
end

%SMOOTHING SIGNATURE SEGMENTS
for h=1:length(x);
    for i=1:length(puzzle(h).edge(:,1))
        puzzle(h).edge{i,1} = SmootherSegments(puzzle(h).edge{i,1},.0000000001);
        puzzle(h).edge{i,2} = SmootherSegments(puzzle(h).edge{i,2},.0000000001);
    end
end

out=puzzle;

end

%%