%INPUT: The following
    %rigidTransformation: rigid transformation matrix calculated in the
        %program estimateRigidTransform.m
    %puzzle: The puzzle structure
    %index: Indicates which puzzle piece will be rotated
%FUNCTION: Assembles two matching edges together by using the rigid 
    %transformation matrix from estimateRigidTransform.m
%OUTPUT: Rotated piece so that edges of matching pieces are assembled
    %together


function out = RotatePiece(rigidTransformation,puzzle,index)
rotation    = rigidTransformation(1:3,1:3);
translation = rigidTransformation(1:3,4);

%UPDATING ROTATED PIECE
for j=1:length(puzzle(index).piece(:,1))
    puzzle(index).piece(j,:) = (rotation*(puzzle(index).piece(j,:))'+translation)';
end
for j=1:length(puzzle(index).edge(:,1))
    for l=1:length(puzzle(index).edge{j,1}(:,1))
        puzzle(index).edge{j,1}(l,:) = (rotation*(puzzle(index).edge{j,1}(l,:))'+translation)';
    end
end
for j=1:length(puzzle(index).edge(:,1))
    for l=1:length(puzzle(index).edge{j,4}(:,1))
        puzzle(index).edge{j,4}(l,:) = (rotation*(puzzle(index).edge{j,4}(l,:))'+translation)';
    end
end

out = puzzle;

end



%%